searchNodes=[{"doc":"Configures a resource to be archived instead of destroyed for all destroy actions. For more information, see {{link:ash_archival:guide:Archival}}. DSL Documentation Index archive Docs archive A section for configuring how archival is configured for a resource. :archive_related - A list of relationships that should have all related items archived when this is archived. Note: this is currently not optimized. It simply reads the relationship and archives each one (by calling its primary destroy, so the related resource must also use the archival extension). When bulk actions are supported by Ash then this can be updated to use those.","ref":"AshArchival.Resource.html","title":"AshArchival.Resource","type":"module"},{"doc":"Introspection helpers for AshArchival.Resource","ref":"AshArchival.Resource.Info.html","title":"AshArchival.Resource.Info","type":"module"},{"doc":"","ref":"AshArchival.Resource.Info.html#archive_related/1","title":"AshArchival.Resource.Info.archive_related/1","type":"function"},{"doc":"Sets up the required resource structure for archival","ref":"AshArchival.Resource.Transformers.SetupArchival.html","title":"AshArchival.Resource.Transformers.SetupArchival","type":"module"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshArchival.Resource.Transformers.SetupArchival.html#after_compile?/0","title":"AshArchival.Resource.Transformers.SetupArchival.after_compile?/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"AshArchival.Resource.Transformers.SetupArchival.html#after?/1","title":"AshArchival.Resource.Transformers.SetupArchival.after?/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"AshArchival.Resource.Transformers.SetupArchival.html#before?/1","title":"AshArchival.Resource.Transformers.SetupArchival.before?/1","type":"function"},{"doc":"","ref":"AshArchival.Resource.Transformers.SetupArchival.html#sort_after/1","title":"AshArchival.Resource.Transformers.SetupArchival.sort_after/1","type":"function"},{"doc":"","ref":"AshArchival.Resource.Transformers.SetupArchival.html#sort_before/1","title":"AshArchival.Resource.Transformers.SetupArchival.sort_before/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"AshArchival.Resource.Transformers.SetupArchival.html#transform/1","title":"AshArchival.Resource.Transformers.SetupArchival.transform/1","type":"function"},{"doc":"","ref":"archival.html","title":"Archival","type":"extras"},{"doc":"This extension modifies a resource in the following ways. Adds a private archived_at utc_datetime_usec attribute. Adds a base filter to the resource, for is_nil(archived_at) Marks all destroy actions as soft? , turning them into updates Adds a change to all destroy actions that sets archived_at to the current timestamp Adds a change that will iteratively load and destroy anything configured in {{link:ash_archival:option:resource-archival/archive/archive_related}}","ref":"archival.html#extension","title":"Archival - Extension","type":"extras"},{"doc":"Performance of Archive Related {{link:ash_archival:option:resource-archival/archive/archive_related}} is a simple iterative process. It is performed synchronously, and therefore is not suited for large cardinality relationships. Eventually, when bulk actions are supported, this can be migrated to use that. If you need to archive a very large amount of related things, you will need to write a custom change to handle this. Un-archiving At the moment, there is no way to unarchive an entry with a simple action on that resource. However, if you define a simple resource that uses the same storage under the hood (e.g same database table), but does not use the archival extension. You could then fabricate unarchival with something like this (this is not vetted, it is a pseudo-code example): # on the archived resource # we model it as a create because there is no input record create :unarchive do manual? true argument :id , :uuid do allow_nil? false end change Unarchive end with an Unarchive change like this def change ( changeset , _ , _ ) do # no data yet, so match on result being `nil` Ash.Changeset . after_action ( changeset , fn changeset , nil -&gt; id = Ash.Changeset . get_argument ( changeset , :id ) ResourceWithoutArchival |&gt; Ash.Query . filter ( id == ^ id ) |&gt; Api . read_one ( ) |&gt; case do { :ok , nil } -&gt; # not found error { :ok , found } -&gt; # unarchive found |&gt; Ash.Changeset . for_update ( :update , %{ archived_at : nil } ) |&gt; Api . update! ( ) { :ok , Api . get! ( changeset . resource , id ) } end end ) end","ref":"archival.html#considerations","title":"Archival - Considerations","type":"extras"}]